#include "ell/MultiStateValue.hh"

namespace ell {



bool 
MultiStateValue::StateValue::operator<(const StateValue& toCompare) const {
	return (basinIndex < toCompare.basinIndex);
}

 
MultiStateValue::StateValue::StateValue()
 :	basinIndex(INT_MAX), minNeigh()	, minNeighE(0.0){
}

 
MultiStateValue::StateValue::StateValue( size_t index, const double E, const CSequence cs)
 :	basinIndex(index),  minNeigh(cs) , minNeighE(E){
}

 
MultiStateValue::StateValue::StateValue( size_t index, double E)
 :	basinIndex(index), minNeighE(E){
	minNeigh.clear();
}

 
MultiStateValue::StateValue::~StateValue()	{
}

//
//bool 
//StateValue::operator<(const StateValue& toCompare) const {
//	return (basinIndex < toCompare.basinIndex);
//}
//
//StateValue::StateValue()
// :	basinIndex(INT_MAX), minNeigh()	, minNeighE(0.0){
//}
//
//StateValue::StateValue( size_t index, const double E, const CSequence cs)
// :	basinIndex(index),  minNeigh(cs) , minNeighE(E){
//}
//
//StateValue::StateValue( size_t index, double E)
// :	basinIndex(index), minNeighE(E){
//	minNeigh.clear();
//}
//
//StateValue::~StateValue()	{
//}


////////////////////////////////////////////
// MultiStateValue //////////////////////////////
////////////////////////////////////////////


MultiStateValue::MultiStateValue()
 :	basinIndex(INT_MAX), minBasinNeighbors()  { }

MultiStateValue::~MultiStateValue() {	}


MultiStateValue::const_iterator
MultiStateValue::begin() const {
	return minBasinNeighbors.begin();
}


MultiStateValue::const_iterator
MultiStateValue::end() const {
	return minBasinNeighbors.end();
}

}  // namespace ell
