#include "ell/SC_Maximum.hh"
#include "iostream"
#include <cmath>
using namespace std;

namespace ell
{

	SC_Maximum::SC_Maximum()
	 :	SC_Counting(), maximum(NULL), maximumE(-(double)UINT_MAX)
	{
	}
	
	SC_Maximum::~SC_Maximum()
	{
		delete lastAdded;
		lastAdded = NULL;
		
		delete maximum;
		maximum = NULL;
	}

	  // This function is used to track all added States.
	  // @param s the State to add
	void 
	SC_Maximum::add(const State& s) {
		if(s.getEnergy() > maximumE) {
			delete maximum;
			maximum = s.clone();
			maximumE = s.getEnergy(); 
		}		
		
#ifdef DEBUG
//		cerr<<"SC_Maximum::add "<<s.toString()<<std::endl;
#endif
		delete lastAdded;
		lastAdded = s.clone();
		stateCount++;
	}
	

}
