#include "ell/fromString.hh"
using namespace biu;

namespace ell {

//S_RNAfe_SingleM*
//fromString(string& str);
//}
S_RNAfe_SingleM*
fromString(string& str) {
	if(str.size() == 0)
		return NULL;
	
	int i, j, k, l;
	
	// indices of (GAUCUA...AGUA) sequence substring
	i = str.rfind('(') +1;
	j = str.rfind(')');
	// indices of .((...))... structure substring
	k = min(str.find('('), str.find('.'));
	l = i-1;
	
	if(l-k != j-i) return NULL;
	
	string seq = str.substr(i, j-i);
	string struc = str.substr(k, l-k);
	    
    if(!RNAFreeEnergy::getSequenceAlphabet()->isAlphabetString(seq)) {
    	cerr << "ERROR: in fromString(): given sequence string is not valid!"<<endl;
    	return NULL;
    }
    
    if(!RNAStructure::getStructureAlphabet()->isAlphabetString(struc)) {
    	cerr << "ERROR: in fromString(): given structure string is not valid!"<<endl;
    	return NULL;
    };
	
//	cout << "sequence: \'"<< seq << "\' and structure: \'"<< struc<<"\'"<<endl;
	
	RNAFreeEnergy* rna = new RNAFreeEnergy(seq, struc);
	
	if(!rna->isValid()) {
		delete rna;
		return NULL;
	} else {
		delete rna;
		return new S_RNAfe_SingleM(seq, struc);
	}
}

}
