#ifndef DJBHASH_HH_
#define DJBHASH_HH_


#include <ell/State.hh>


		/*! Daniel J. Bernstein's string hash function for ell::State pointers
		 *  taken from http://www.cs.yorku.ca/~oz/hash.html.
		 *
		 *  @author Andreas Richter
		 */ 


class DJBHash {
public:
	size_t operator()(const ell::State* StatePtr) const {
		unsigned long hash = 5381;
		ell::CSequence cSeq = StatePtr->compress();

		for (size_t i = 0; i < cSeq.size(); i++) {
			hash = ((hash << 5) + hash) + cSeq[i]; // hash * 33 + cSeq[i]
		}

		return hash;
	}
};

#endif /*DJBHASH_HH_*/






