#include "ell/directWalk.hh"
#include <ell/SC_Counting.hh>
#include "ell/SC_Maximum.hh"

using namespace std;
using namespace biu;
using namespace ell;

int main(int argc, char **argv) {
	
	RandomNumberGenerator* rng = new RNG_LCG();
	RNF::setRNG( rng );
	RNF::getRNG().setSeed(1);
	
	string sequence =   "GCAUUCUACCGAAAGCGC";
	string structureA = "((.(((....)))...))";
	string structureB = "((.((.(....)))))..";
	
	S_RNAfe_SingleM*	rnaA = new S_RNAfe_SingleM(sequence,structureA);
	S_RNAfe_SingleM*	rnaB = new S_RNAfe_SingleM(sequence,structureB);
	SC_Counting* scc = new SC_Counting();
	
	double energy = directWalk(rnaA, rnaB, scc, 3000);	

	cout << "Anzahl States auf dem direct Walk: "<<scc->size()<<endl;
	cout << "Energie: "<<energy<<endl;
	
	delete rng;
	return 0;
}



